"use strict";
/**
 * Created by amin on 9/28/16.
 */
const FileMessage_1 = require("./FileMessage");
const ApiConst_1 = require("../../api/ApiConst");
class PhotoMessage extends FileMessage_1.FileMessage {
    constructor(messageObjOrFileId, accessHash, name, fileSize, mimeType, width, height, thumb, captionText) {
        super(messageObjOrFileId, accessHash, name, fileSize, mimeType);
        this._width = 500;
        this._height = 400;
        if (accessHash) {
            this._width = width;
            this._height = height;
            this._thumb = thumb;
            this._captionText = captionText;
        }
    }
    get width() {
        return this._width;
    }
    get height() {
        return this._height;
    }
    get thumb() {
        return this._thumb;
    }
    get captionText() {
        return this._captionText;
    }
    set captionText(value) {
        this._captionText = value;
    }
    getJsonObject() {
        let obj = super.getJsonObject();
        obj.thumb[0] = {
            width: this._width,
            height: this._height,
            thumb: this._thumb
        };
        obj.ext[0] = {
            $type: ApiConst_1.ApiConst.ExtTypes.Photo,
            width: this._width,
            height: this._height,
        };
        obj.caption = [{
                $type: "Text",
                text: this._captionText
            }];
        obj.checkSum = [];
        obj.algorithm = [];
        return obj;
    }
    manipulateFromJsonObject(jsonObject) {
        super.manipulateFromJsonObject(jsonObject);
        let t = jsonObject.thumb[0];
        if (t.width)
            this._width = t.width;
        if (t.height)
            this._height = t.height;
        if (t.thumb)
            this._thumb = t.thumb;
    }
}
exports.PhotoMessage = PhotoMessage;
//# sourceMappingURL=PhotoMessage.js.map